Subject: Restoring the Hurd on core-packages-team branch
From: [email-masked]
To: [email-masked]
Date: Thu, 10 Apr 2025 16:55:15 +0200 (CEST)
List-Id: <debbugs-submit.debbugs.gnu.org>

Hello,

Here are all of the things I had to do to restore the (32bit) Hurd on core-packages-team branch

- gnumach incompatible with [email-masked]

Our current gnumach does not build with [email-masked]. This got fixed for gnumach and gnumach-headers in hurd.scm by using [email-masked] but not in commencement.scm.

Probably the better solution is to instead refresh hurd/mach and friends to their latest snapshots which includes the fix for [email-masked]

- The same 4 gnulib tests would fail in a lot of packages: coreutils grep libunistring diffutils findutils sed m4 gettext

  As these were fine with [email-masked] this seems to be a regression in glibc.
  
* test-once1 and bison segfaulting
Fixed with
https://salsa.debian.org/glibc-team/glibc/-/commit/22f0a9381fe844a5de92a57012833bec225a9686
https://sourceware.org/git/?p=glibc.git;a=commit;h=ccdb68e829a31e4cda8339ea0d2dc3e51fb81ba5

* test-pthread_sigmask1

https://salsa.debian.org/glibc-team/glibc/-/commit/6c823b5862bd91ca757eeb9c6f5326875bc8af01

* test-symlink and test-symlinkat

https://sourceware.org/bugzilla/show_bug.cgi?id=32569
https://sourceware.org/git/?p=glibc.git;a=commit;h=8ef17919509e909746b0ad6465e9c6c952a3fe34 causes

mkdir("dir")
symlink("nowhere", "dir/")

to fail with ENOTDIR (previously it was EINVAL). On Linux it is EEXIST

- The disable-year-2038 configure flag

Some packages (findutils, tar, util-linux [latest coreutils, currently not yet updated]) have a configure time fatal check for 64bit time_t whcih needs to explicitly be disabled if not supported.

This is also relevant for other 32 bit platforms.

- rumpkernel : Implicit function declaration

It fails to build because of gcc14 and -Wimplicitit-function-declaration

there is a newer tag on the debian repo but I struggled to understand the build system.

- Some test failures:

openssl, [email-masked] and bison

I have not looked into these yet,

- Flaky tests:
tar, curl

It should also be possible to build hurd with a more recent texinfo.

With all of these dealt with I could build all of a slightly modified hurd-manifest (all of these are not new problems and also fail on the master branch).
- Removed  gdk-pixbuf (dbus is failing https://gitlab.freedesktop.org/dbus/dbus/-/commit/5d7b87496f3bb094b926692036ae656c31efdd8e and I havent looked further)
- Removed guix
- Removed patch (it #+ includes gnulib , which fails because of clisp)
- Skipped tests in grep: Triple-backref test fails
- Skipped tests in libgit2: The last one fails
- Skipped tests in guile-fibers: One test hangs
- Skipped tests in shepherd #77634

I hope this helps.